/*
 * Copyright (c) 2022 Contributors to the Eclipse Foundation.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *   Data In Motion - initial API and implementation 
 */
package org.eclipse.sensinact.model.core.testdata;

import org.eclipse.sensinact.model.core.provider.Service;

import org.osgi.annotation.versioning.ProviderType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Test Temperatur</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV1 <em>V1</em>}</li>
 *   <li>{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV2 <em>V2</em>}</li>
 * </ul>
 *
 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestTemperatur()
 * @model
 * @generated
 */
@ProviderType
public interface TestTemperatur extends Service {
	/**
	 * Returns the value of the '<em><b>V1</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>V1</em>' attribute.
	 * @see #setV1(String)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestTemperatur_V1()
	 * @model
	 * @generated
	 */
	String getV1();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV1 <em>V1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>V1</em>' attribute.
	 * @see #getV1()
	 * @generated
	 */
	void setV1(String value);

	/**
	 * Returns the value of the '<em><b>V2</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>V2</em>' attribute.
	 * @see #setV2(String)
	 * @see org.eclipse.sensinact.model.core.testdata.TestdataPackage#getTestTemperatur_V2()
	 * @model
	 * @generated
	 */
	String getV2();

	/**
	 * Sets the value of the '{@link org.eclipse.sensinact.model.core.testdata.TestTemperatur#getV2 <em>V2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>V2</em>' attribute.
	 * @see #getV2()
	 * @generated
	 */
	void setV2(String value);

} // TestTemperatur
